# ![](./docs/images/readme/Reactotron-128.png)

[![Slackin](https://infiniteredcommunity.herokuapp.com/badge.svg)](https://infiniteredcommunity.herokuapp.com/)

[Less Talk More Action](./docs/installing.md)

# What is Reactotron?

An OS X app for inspecting your [React JS](https://facebook.github.io/react/) and [React Native](https://facebook.github.io/react-native/) apps.

Use it to:

* view your application state
* show API requests & responses
* perform quick performance benchmarks
* subscribe to parts of your application state
* display messages similar to console.log
* track global errors with source-mapped stack traces including saga stack traces!
* dispatch actions like a government-run mind control experiment
* hot swap your app's state
* track your sagas
* show image overlay in React Native
* track your Async Storage in React Native

You plug it into your app as a dev dependency so it adds nothing to your product builds.

### Desktop

Reactotron on the left, demo React Native app on the right.

![Desktop](./docs/images/readme/reactotron-demo-app.gif)

# Documentation

* [Installing](./docs/installing.md)
* Quick start for [React JS](./docs/quick-start-react-js.md)
* Quick start for [React Native](./docs/quick-start-react-native.md)
* [Tracking errors globally](./docs/plugin-track-global-errors.md)
* [Open in editor](./docs/plugin-open-in-editor.md)
* [Image Overlays](./docs/plugin-overlay.md)
* [Async Storage](./docs/plugin-async-storage.md)
* Integrating with [Redux](./docs/plugin-redux.md)
* Integrating with [Redux Saga](./docs/plugin-redux-saga.md)
* Networking monitoring with [Apisauce](./docs/plugin-apisauce.md)
* [Troubleshooting](./docs/troubleshooting.md)
* [Tips and Tricks](./docs/tips.md)
* [Release Notes](https://github.com/reactotron/reactotron/releases)

#### Coming Soon

* API Docs
* Integrating with Fetch
* Creating your own plugins
* The JSON interface between client & server (coming soon...)
* What's Inside This Repo?
* Contributors Quick Start

## Premium Support

[Reactotron](https://github.com/infinitered/reactotron), as open source projects, is free to use and always will be. [Infinite Red](https://infinite.red/) offers premium Reactotron support and general mobile app design/development services. Email us at [hello@infinite.red](mailto:hello@infinite.red) to get in touch with us for more details.
